package NTLSystem.verblearn;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyVetoException;

class GenerateGUI
extends JInternalFrame
{

  private static int    defScenesToGen = 50;
  private static String defNameStem = "sc";
  private static int    defStartIdx = 0;

  private JTextField scenesToGen;
  private JTextField nameStem;
  private JTextField startIdx;

  private JPanel fstructs;

  public GenerateGUI()
  {
    super("Scenario Generation", true, true, true, true);

    GridBagLayout gbl, gblTmp;
    GridBagConstraints c = new GridBagConstraints();
    JPanel jp;
    JLabel jl;
    JButton jb;

    JComponent cp = (JComponent)getContentPane();

    gblTmp = new GridBagLayout();
    jp = new JPanel(gblTmp);
    
    jp.setBorder(BorderFactory.createTitledBorder("Generate..."));

    c.gridwidth = GridBagConstraints.RELATIVE;
    c.fill = GridBagConstraints.NONE;
    jl = new JLabel("Scenarios to generate:");
    gblTmp.setConstraints(jl, c);
    jp.add(jl);

    c.gridwidth = GridBagConstraints.REMAINDER;
    c.fill = GridBagConstraints.HORIZONTAL;
    scenesToGen = new JTextField( new Integer(defScenesToGen).toString() , 10);
    gblTmp.setConstraints(scenesToGen, c);
    jp.add(scenesToGen);

    c.gridwidth = GridBagConstraints.RELATIVE;
    c.fill = GridBagConstraints.NONE;
    jl = new JLabel("Name stem:");
    gblTmp.setConstraints(jl, c);
    jp.add(jl);

    c.gridwidth = GridBagConstraints.REMAINDER;
    c.fill = GridBagConstraints.HORIZONTAL;
    nameStem = new JTextField( defNameStem , 10);
    gblTmp.setConstraints(nameStem, c);
    jp.add(nameStem);
    
    c.gridwidth = GridBagConstraints.RELATIVE;
    c.fill = GridBagConstraints.NONE;
    jl = new JLabel("Start index:");
    gblTmp.setConstraints(jl, c);
    jp.add(jl);

    c.gridwidth = GridBagConstraints.REMAINDER;
    c.fill = GridBagConstraints.NONE;
    startIdx = new JTextField( new Integer(defStartIdx).toString() , 10);
    gblTmp.setConstraints(startIdx, c);
    jp.add(startIdx);

    gbl = new GridBagLayout();
    cp.setLayout(gbl);

    c.gridwidth = GridBagConstraints.RELATIVE;
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    gbl.setConstraints(jp, c);
    cp.add(jp);

    gblTmp = new GridBagLayout();
    jp = new JPanel(gblTmp);
    jp.setBorder(BorderFactory.createTitledBorder("Restrictions"));
    //NC: changed what looks like a typo below to correct jp above. ? 
    //jb.setBorder(BorderFactory.createTitledBorder("Restrictions"));

    c.anchor = GridBagConstraints.CENTER;
    c.fill = GridBagConstraints.NONE;
    c.gridwidth = GridBagConstraints.REMAINDER;
    c.weightx = 0.0;
    jl = new JLabel("FIXME: Restrictions.");
    gblTmp.setConstraints(jl, c);
    jp.add(jl);

    c.gridwidth = GridBagConstraints.REMAINDER;
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    gbl.setConstraints(jp, c);
    cp.add(jp);

    c.gridwidth = GridBagConstraints.REMAINDER;
    c.weightx = c.weighty = 1.0;
    c.fill = GridBagConstraints.BOTH;
    fstructs = new JPanel();
    // FIXME: Add the 'template' fstructs in here.
    fstructs.setPreferredSize( new Dimension(700, 350) );
    JScrollPane jsp = new JScrollPane( fstructs );
    gbl.setConstraints(jsp, c);
    cp.add(jsp);

    c.gridwidth = GridBagConstraints.REMAINDER;
    c.anchor = GridBagConstraints.CENTER;
    c.fill = GridBagConstraints.NONE;
    c.weightx = c.weighty = 0.0;
    jb = new JButton("Generate");
    // FIXME: rig this button to _do_ something... interface with VL code.
    gbl.setConstraints(jb, c);
    cp.add(jb);
    
    pack();
    setVisible(true);
  }

}
