package NTLSystem.features;

import NTLSystem.NTLException;

/**
 * An exception used thrown by EditableDataElement implementers
 * stating that edited values cannot be saved back to the object.
 * <P>
 * $Id: CannotSaveValuesException.java,v 1.2 1998/10/16 01:56:59 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @author    Josh Sled [jsled@icsi.berkeley.edu]
 * @see       EditableDataElement
 * @version   $Revision: 1.2 $
 **/

public class CannotSaveValuesException
extends NTLException
{
  /** A new NTLException without a message. **/
  public CannotSaveValuesException() { super(); }
  /**
   * A new NTLException with a message.
   *
   * @param     m The message text.
   **/
  public CannotSaveValuesException(String m) { super(m); }
}

