package NTLSystem.features;

import NTLSystem.NTLException;

/**
 * An Exception to be thrown when a Feature cannot be found.
 * <P>
 * $Id: NoSuchFeatureException.java,v 1.2 1998/10/16 01:57:13 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @author    Joshua Sled [jsled@icsi.berkeley.edu]
 * @see       NTLException
 * @version   $Revision: 1.2 $
 **/
public class NoSuchFeatureException
extends NTLException
{
  public NoSuchFeatureException()
  {
    super();
  }

  public NoSuchFeatureException(String message)
  {
    super(message);
  }
}
